/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * RandomNumberDistributionFactory.cpp
 *
 *  Created on: Jan 03, 2011
   Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include <utility>
#include "CodePatterns/Singleton_impl.hpp"
#include "CodePatterns/Assert.hpp"

#include <boost/random/bernoulli_distribution.hpp>
#include <boost/random/binomial_distribution.hpp>
#include <boost/random/cauchy_distribution.hpp>
#include <boost/random/exponential_distribution.hpp>
#include <boost/random/gamma_distribution.hpp>
#include <boost/random/geometric_distribution.hpp>
#include <boost/random/linear_congruential.hpp>
#include <boost/random/lognormal_distribution.hpp>
#include <boost/random/normal_distribution.hpp>
#include <boost/random/poisson_distribution.hpp>
#include <boost/random/triangle_distribution.hpp>
#include <boost/random/uniform_01.hpp>
#include <boost/random/uniform_int.hpp>
#include <boost/random/uniform_on_sphere.hpp>
#include <boost/random/uniform_real.hpp>
#include <boost/random/uniform_smallint.hpp>

#include "RandomNumberDistribution_Encapsulation.hpp"

#include "RandomNumberDistributionFactory.hpp"

// has to be included BEFORE PrototypeFactory_impl.hpp!
#include "RandomNumberDistributionFactory.def"
#include "CodePatterns/PrototypeFactory_impl.hpp"

RandomNumberDistributionFactory::RandomNumberDistributionFactory()
{
  FillPrototypeTable();
}

RandomNumberDistributionFactory::~RandomNumberDistributionFactory()
{
  EmptyPrototypeTable();
}

CONSTRUCT_SINGLETON(RandomNumberDistributionFactory)
CONSTRUCT_PROTOTYPEFACTORY(RandomNumberDistribution)

#include "RandomNumberDistributionFactory.undef"

