/*
 * Project: MoleCuilder
 * Description: creates and alters molecular systems
 * Copyright (C)  2010 University of Bonn. All rights reserved.
 * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
 */

/*
 * RandomNumberEngineFactory.cpp
 *
 *  Created on: Jan 03, 2011
 *      Author: heber
 */

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "CodePatterns/MemDebug.hpp"

#include <utility>
#include "CodePatterns/Singleton_impl.hpp"
#include "CodePatterns/Assert.hpp"

#include <boost/nondet_random.hpp>
#include <boost/random.hpp>
#include <boost/random/additive_combine.hpp>
#include <boost/random/discard_block.hpp>
#include <boost/random/inversive_congruential.hpp>
#include <boost/random/lagged_fibonacci.hpp>
#include <boost/random/linear_congruential.hpp>
#include <boost/random/linear_feedback_shift.hpp>
#include <boost/random/mersenne_twister.hpp>
#include <boost/random/random_number_generator.hpp>
#include <boost/random/ranlux.hpp>
#include <boost/random/shuffle_output.hpp>
#include <boost/random/subtract_with_carry.hpp>
#include <boost/random/xor_combine.hpp>

#include "RandomNumberEngine_Encapsulation.hpp"

#include "RandomNumberEngineFactory.hpp"

// has to be included BEFORE PrototypeFactory_impl.hpp!
#include "RandomNumberEngineFactory.def"
#include "CodePatterns/PrototypeFactory_impl.hpp"

RandomNumberEngineFactory::RandomNumberEngineFactory()
{
  FillPrototypeTable();
}

RandomNumberEngineFactory::~RandomNumberEngineFactory()
{
  EmptyPrototypeTable();
}

CONSTRUCT_SINGLETON(RandomNumberEngineFactory)
CONSTRUCT_PROTOTYPEFACTORY(RandomNumberEngine)

#include "RandomNumberEngineFactory.undef"

